#pragma once
// SPDX-License-Identifier: GPL-2.0-or-later
// Copyright (C) 2019 The MMapper Authors
// Author: Thomas Equeter <waba@waba.be> (Waba)

#include <QObject>
#include <QString>
#include <QtCore>
#include <QtGlobal>

class ProgressCounter final : public QObject
{
    Q_OBJECT

    quint32 m_totalSteps = 0u, m_steps = 0u, m_percentage = 0u;

public:
    ProgressCounter() = default;
    explicit ProgressCounter(QObject *parent);
    virtual ~ProgressCounter() override = default;

public:
    void step(quint32 steps = 1u);
    void increaseTotalStepsBy(quint32 steps);
    void reset();

signals:
    void onPercentageChanged(quint32);
};
